/* Written by Filip Hlasek 2014 */
#include <cstdio>
#include <map>

using namespace std;

// Ze standartniho vstupu cte soubor vygenerovany pomoci extract_data.py
// Na standartni vystup vypisuje radky ve formatu: id lat lon

map<int, pair<double, double> > objects;

int main(int argc, char *argv[]) {
  int id, member_id, members;
  double lat, lon;
  int progress = 0, output_progress = 0;
  while (scanf("%d", &id) != EOF) {
    if ((++progress) % 1000000 == 0) fprintf(stderr, "progress: %d\n", progress);
    scanf("%d", &members);
    if (members) {
      lat = lon = 0;
      for (int i = 0; i < members; ++i) {
        scanf("%d", &member_id);
        lat += objects[member_id].first / members;
        lon += objects[member_id].second / members;
      }
      printf("%d %.7lf %.7lf\n", id, lat, lon);
      if ((++output_progress) % 100000 == 0)
        fprintf(stderr, "output_progress: %d\n", output_progress);
    }
    else scanf("%lf%lf", &lat, &lon);
    objects[id] = make_pair(lat, lon);
  }
  return 0;
}
