#!/usr/bin/python
#-*- coding: utf-8 -*-

# Soubor .osm (OpenStreetMaps) obsahuje nasledujiich 6 zakladnich tagu:
#   node - popisuje bod na mape
#   way - seznam bodu
#     nd - jeden bod cesty (way)
#   relation - shlukuje jine objekty (relation, way nebo node)
#     member - popisuje prvky relation
#   tag - pripisuje vlastnosti typu node, way nebo relation (napr. jmeno)

import sys
reload(sys)
sys.setdefaultencoding('utf-8')

# Hint soubor obsahuje souradnice objektu, ktere jsou typu relation nebo way

def usage():
  print("Pouziti: %s osm_filename hint_filename" % sys.argv[0])
  sys.exit()

if len(sys.argv) != 3: usage()
FILE_NAME = sys.argv[1]
hint_file = open(sys.argv[2], "r")

import xml.sax
class Handler (xml.sax.handler.ContentHandler):
  forbidden_tag_keys = set("source wheelchair created_by barrier foot horse bicycle wikipedia year_of_construction width website waterway url crossing_ref uir_adr:ADRESA_KOD ref populaion postal_code phone opening_hours dibavod:id addr:housenumber addr:conscriptionnumber addr:postcode addr:streetnumber import addr:alternatenumber addr:provisional addr:provisionalnumber addr:streetnumber capacity collection_times color contact:email contact:phone de:amtlicher_gemeindeschluessel distance ele email fax height hour_on hour_off maxheight maxweight name:de name:en name:pl name:fr name:ru".split())
  forbidden_tag_values = set("crossing level_crossing traffic_signals".split())

  # Nasledujici promenne se vztahuji k aktualnimu objektu
  current_id = 0
  lat, lon = 0, 0
  tags = {}

  nodes = 0

  def startElement (self, name, attrs):
    if name in ("node", "way", "relation"):
      self.current_id = int(attrs.get('id'))
      self.tags = {}
    if name == "node":
      self.lat, self.lon = float(attrs.get('lat')), float(attrs.get('lon'))
    elif name == "tag":
      key, value = attrs.get('k'), attrs.get('v')
      if key not in self.forbidden_tag_keys and value not in self.forbidden_tag_values:
        self.tags[key] = value

  def endElement (self, name, attrs = None):
    global hint_file

    if name in ("way", "relation"):
      hint = hint_file.readline().split()
      if int(hint[0]) != self.current_id:
        sys.stderr.write("Chyba! Ocekvane ID: %d, Nalezene ID: %d\n" %
                         (self.current_id, int(hint[0])))

      self.lat, self.lon = float(hint[1]), float(hint[2])

    if name in ("node", "way", "relation"):
      self.nodes += 1
      if (self.nodes % 10 ** 6 == 0):
        sys.stderr.write("nodes proceeded: %d\n" % self.nodes)
      result = self.processNode()
      if (result != None):
        print("%.7lf %.7lf %s %s" % (self.lat, self.lon, result[1], result[0]))

  def processNode(self): # Vrati bude None, nebo dvojici (nazev, typ_mista)
    if "name" in self.tags.keys():
      name = self.tags["name"]
      if self.tags.get("place") in ("village",): return (name, "village")
      elif self.tags.get("highway") in ("residental",): return (name, "street")
      elif self.tags.get('railway') in ('tram_stop',): return (name, "tram_stop")
      elif self.tags.get('highway') in ('bus_stop',): return (name, "bus_stop")
      elif self.tags.get('historic') in ('castle',): return (name, "tram_stop")
      elif self.tags.get('railway') in ('station', 'halt'): return (name, "railway")
      elif self.tags.get("landuse") in ("residental", "industrial"):
        return (name, self.tags["landuse"])
      # else:
      #  return (name, u"other")

    elif "addr:street" in self.tags.keys():
      return (self.tags['addr:street'], "street")

    return None

xml.sax.parse (FILE_NAME, Handler())

hint_file.close()
