#ifndef CONFIG_H
#define CONFIG_H

#include "src/lib/include.h"

#define P 26 // pocet pismen zkoumane abecedy

const unsigned MAX_INPUT_SIZE = 500;
const unsigned MAX_PRINT_SOLUTION = 10; // kolik nejlepsich reseni se ma vypisovat

const unsigned N_MAX = 2;

const bool PHASE_1 = true; // ma se provadet 1. faze vypoctu?
const bool PHASE_2 = true; // ma se provadet 2. faze vypoctu?

#define ALG_DFS 1
#define ALG_BFS 2
const unsigned ALG = ALG_DFS;

// nejdelsi delka slova, pro ktere se generuji vsechny varianty
const unsigned MAX_LENGTH_TO_GENERATE_VARIANTS = 8;
// slouzi k jednodussi staticke alokaci vrcholu trie
const unsigned MAX_TRIE_SIZE = 4300000;

#define ORDER_C 1
#define ORDER_L 2
#define ORDER_CL 3
const unsigned ORDER = ORDER_CL;

// pocet sekund, po kterem se vypocet zrychli, a po kterem se ukonci
const unsigned MAX_TIME1 = 60, MAX_TIME2 = 300;

const unsigned COST_DIFF = 250; // = L * log (|T|)

// urcuje, zda se maji vypisovat ladici informace o prubehu vyhledavani
const bool PROGRESS = false;
// po kolika krocich prohledavani se ma vypisovat ladici vystup
const unsigned PROGRESS_STEPS = 100000;

const string wordlist_dir = "./wordlists/";
const string categories_config_filename = wordlist_dir + "categories.cfg";
const string rules_config_filename = wordlist_dir + "rules.cfg";

const string geography_filename = wordlist_dir + "places";
const double MAX_DISTANCE = 3; // okruh 3 kilometru vzdusnou carou
const double EARTH_RADIUS = 6371;

// maximalni velikost haldy pri hledani do sirky
const unsigned BFS_MAX_HEAP_SIZE = 50000;

#endif
