#!/usr/bin/python
#-*- coding: utf-8 -*-

# Tento skript slouzi k vyhledavani ulic, obci a casti obci v ceskych adresach.
# Umi filtrovat okresy, popr. kraje a varuje pred vypsanim velkeho mnozstvi dat najednou.

import sys
from functions import *
FILE_NAME = "../geography/adresy.xml"
MAX_PRINT_NO_ASK = 20 # Pokud je nalezeno vice zaznamu, tak je uzivatel dotazan jestli je chce vypsat
MIN_LETTERS = 4 # nejmensi pocet pismen, ktere musi nazev mit
USAGE = 'Pouziti: %s [-f] [--obec] [--cast] [--kraj seznam_kraju] [--okres seznam_okresu]' % sys.argv[0]
SEARCH_WORD = "ulice"

def usage (error = ""):
  print USAGE
  if error:
    print ""
    print error
  sys.exit()

force = False
regions, subregions = [], []

# Zpracovani argumentu skriptu
argv = sys.argv[:]
argv.reverse()
argv.pop()
while argv:
  arg = argv.pop()
  if arg == '-f': force = True
  elif arg == '--kraj' or arg == '-k':
    if regions: usage("Option --kraj se nemuze vyskytovat vicekrat!")
    if not argv: usage("Po --kraj musi nasledovat stredniky oddeleny seznam kraju!")
    regions = argv.pop().split(';')
  elif arg == '--okres':
    if subregions: usage("Option --okres se nemuze vyskytovat vicekrat!")
    if not argv: usage("Po --okres musi nasledovat stredniky oddeleny seznam okresu!")
    subregions = argv.pop().split(';')
  elif arg == '--obec': SEARCH_WORD = "obec"
  elif arg == '--cast': SEARCH_WORD = "cast"
  else: usage("Neznamy option %s" % arg)

if not force: print USAGE

# V nasledujicim kodu muze street znamenat take obec, popr. cast obce, nebot
# tato funkcnost byla doplnena o neco pozdeji.
streets, all_regions, all_subregions = set(), set(), set()

import xml.sax
class Handler (xml.sax.handler.ContentHandler):
  region, subregion = "", ""
  regions, subregions = map(normalize, regions), map(normalize, subregions)
  def okRegion (self):
    return self.region in self.regions or not self.regions
  def okSubregion (self):
    return self.subregion in self.subregions or not self.subregions
  def addStreet (self, street):
    if len(street) < MIN_LETTERS or street.isdigit(): return False
    if not (self.okRegion() and self.okSubregion()): return False
    streets.add(street)

  def startElement (self, name, attrs):
    global streets
    if name == SEARCH_WORD: self.addStreet(normalize(attrs.get('nazev')))
    elif name == "oblast":
      region = attrs.get('kraj')
      if not region: region = attrs.get('typ')
      if region:
        region = region.capitalize()
        self.region = normalize(region)
        all_regions.add(region)
        if self.okRegion():
          subregion = attrs.get('nazev')
          if subregion:
            subregion = subregion.capitalize()
            self.subregion = normalize(subregion)
            all_subregions.add(subregion)
    #else: print name, attrs.getNames()

  def endElement (self, name, attrs = None):
    if(name == "oblast"):
      self.region = ""
      self.subregion = ""

xml.sax.parse (FILE_NAME, Handler())
streets = list(streets)
streets.sort()
N = len(streets)

if not force:
  print "  -f (zadne ladici vystupy, zadne dotazy - vhodne pro vystup do souboru)"

all_regions = list(all_regions)
all_regions.sort()
if not force and not regions and not subregions:
  print "  --kraj seznam_kraju (ocekava stredniky oddeleny seznam kraju)"
  for i in all_regions: print "    %s" % i
  print '   Priklad: %s -f --kraj "Olomoucky; Kraj Vysocina"' % sys.argv[0]

all_subregions = list(all_subregions)
all_subregions.sort()
if not force and regions and not subregions:
  print "  --okres seznam_okresu (ocekava stredniky oddeleny seznam okresu)"
  for i in all_subregions: print "    %s" % i
  print '   Priklad: %s -f --kraj Jihocesky --okres "Cesky Krumlov; Prachatice"' % sys.argv[0]

all_regions = map(normalize, all_regions)
for i in regions:
  if normalize(i) not in all_regions:
    print '\nPozor, "%s" nenalezen v seznamu kraju!' % i

all_subregions = map(normalize, all_subregions)
for i in subregions:
  if normalize(i) not in all_subregions:
    print '\nPozor, "%s" nenalezen v seznamu okresu!' % i

if not force: print ""

if not force and N > MAX_PRINT_NO_ASK:
  answer = raw_input ("Nalezeno %d %s. Skutecne chcete vsechny vypsat? ([A]no / [N]e) " % (N, {"ulice":"ulic", "obec":"obci", "cast":"casti"}[SEARCH_WORD]))
if force or N <= MAX_PRINT_NO_ASK or answer in ("A", "Ano", "a", "ano"):
  if N == 0: print "Zadanym kriteriim neodpovida zadna %s." % SEARCH_WORD
  for s in streets: print s
