/*
  code.cpp

  Program slouzi k zakodovani zadaneho textu substitucni sifrou
  pomoci nahodne permutace abecedy.

  vstup  (stdin)  program precte prvni radek
  vystup (stdout) program prelozi pismena, udela z nich mala a
                  vsechny ostatni znaky zahodi

*/
#include <cstdlib>
#include <string>
#include <iostream>
#include <cctype>

using namespace std;

#define P 26
#define SEED 437903
int permutation[P];

// Naplni pole permutation nahodnou permutaci cisel 0, 1, ... , P - 1
void random_permutation () {
  for (int i = 0; i < P; i++) permutation[i] = i;
  for (int i = 0; i < P; i++) swap (permutation[i], permutation[rand() % (i + 1)]);
}

// Zasifruje jeden znak zpravy substitucni sifrou
char translate (char c) {
  return 'a' + permutation[c - 'a'];
}

int main (int argc, char *argv[]) {
  // precteni prvniho radku vstupu
  string line;
  getline (cin, line);

  // nastaveni pseudonahodneho seedu podle aktualniho casu a hashe ze vstupu
  int seed = 0;
  for (size_t i = 0; i < line.size(); i++) seed += line[i];
  srand (SEED + seed);
  random_permutation ();

  // vsechna pismena se prevedou na mala, zakoduji a ulozi do vystupniho retezce
  string code;
  for (size_t i = 0; i < line.size(); i++) {
    char c = tolower (line[i]);
    if (c < 'a' || c > 'z') continue; // znak, ktery neni pismeno, ignorujeme
    code.push_back (translate(c));
  }

  cout << code << endl;

  return 0;
}
