/*
  divide.cpp

  Program slouzi na rozdeleni testovacich dat na tri casti:
    training: slouzi k vyvoji aplikace a tvorbe jazykoveho modelu
    development: slouzi k testovani reseni v prubehu vyvoje (nepouziva se k tvorbe modelu)
    evaluation: tajne sifry, na kterych se bude az na zaver testovat uspesnost reseni
*/

#include <string>
#include <iostream>
#include <fstream>

// popisuje pomer ostrych testovacich dat a tech trenovacich
#define TRAINING 1
#define DEVELOPMENT 1
#define EVALUATION 1

#define SOURCE "../solutions/all" // soubor s testovacimi daty
#define TRAINING_FILE "../solutions/training"
#define DEVELOPMENT_FILE "../solutions/development"
#define EVALUATION_FILE "../solutions/evaluation/testing"

using namespace std;

int main (int argc, char *argv[]) {
  srand (42);

  ifstream solutions;
  solutions.open(SOURCE);

  ofstream training, development, evaluation;
  training.open(TRAINING_FILE);
  development.open(DEVELOPMENT_FILE);
  evaluation.open(EVALUATION_FILE);

  cout << "Rozdeluji \"" << SOURCE << "\""
       << " na \"" << TRAINING_FILE << "\""
       << ", \"" << DEVELOPMENT_FILE << "\""
       << "a \"" << EVALUATION_FILE << "\""
       << " v pomeru " << TRAINING << ":" << DEVELOPMENT << ":" << EVALUATION << " ..." << endl;

  // precteni prvniho radku vstupu
  string line;

  while (true) {
    getline (solutions, line);
    if (line == "") break;
    // prumerne TRAINING / r dat je na testovani, apod.
    int r = rand() % (DEVELOPMENT + TRAINING + EVALUATION);
    if (r < TRAINING) training << line << endl;
    else if (r < TRAINING + DEVELOPMENT) development << line << endl;
    else evaluation << line << endl;
  }

  solutions.close();
  training.close();
  development.close();
  evaluation.close();

  cout << "Rozdelovani uspesne dokonceno." << endl;

  return 0;
}
