#!/usr/bin/python
#-*- coding: utf-8 -*-

# Tento skript cte ze standartniho vstupu nazvy souboru (typicky vystup programu ls).
# V kazdem ze zadanych souboru nalezne slova a vypise vsechna slova, ktera dosud
# nejsou ve wordlistu a zaroven se nachazi alespon v nejakem poctu ze zadanych souboru.

# Minimalni pocet vyskytu potrebny k tomu, abychom slovo brali v uvahu.
MIN_OCCURANCE = 3
import functions

WORDLISTS_DIR = "../wordlists/"

# Nejpve se nactou jiz znama slova
known = set()
def load_known(wordlist):
  f = open(WORDLISTS_DIR + wordlist, 'r')
  for i in f.readlines(): known.add(i.strip())
  f.close()

with open(WORDLISTS_DIR + "categories.cfg", "r") as wordlists:
  for wordlist in wordlists.readlines(): load_known(wordlist.strip())

occurance = {}

# Nacita nazvy souboru, dokud je co cist
while True:
  try: filename = raw_input()
  except EOFError: break

  f = open(filename, "r")
  lines = f.readlines()
  f.close()

  # Kazdy soubor projde a vytahne z nej vsechna slova
  wordlist = set()
  for line_ in lines:
    line = line_.decode("utf-8")
    w = ""
    for i in line:
      i = functions.normalize(i)
      if("0" <= i <= "9" or not i):
        if w and (w not in known): wordlist.add(w)
        w = ""
      else: w += i

  # Vsem nalezenym skovum zvysi cetnost
  for i in wordlist:
    if not occurance.get(i): occurance[i] = 0
    occurance[i] += 1

# Na zaver vypise nalezena slova v lexikografickem poradi
for i in sorted(occurance.keys()):
  if occurance[i] >= MIN_OCCURANCE: print occurance[i], i
