/*
   Hleda reseni prochodem do sirky.
   Vychazi z rozpracovaneho reseni solution (nepovinny argument) a
   z rozpracovane prevodni tabulky _dictionary (taktez nepovinny).
*/
void approach_bfs (const string & input,
                   Solution solution = Solution(),
                   ConversionTable _dictionary = ConversionTable()) {
  priority_queue<Solution, vector<Solution>, greater<Solution> > heap;
  heap.push (solution);
  while (!heap.empty()) {
    solution = heap.top(); heap.pop();
    if (Solution::all.size() >= MAX_PRINT_SOLUTION &&
        Solution::all.top()  <= solution) break;

    ConversionTable dictionary = _dictionary;
    size_t position = 0;
    for (size_t i = 0; i < solution.words.size(); i++) {
      dictionary.match(input, position, Option(solution.words[i]), solution);
      position += solution.words[i]->text.size();
    }

    // Kdyz uz je halda moc velka, tak se to nevejde do pameti a je vhodne prepnout na DFS
    if (heap.size() > BFS_MAX_HEAP_SIZE || time(NULL) - startTime > MAX_TIME1) {
      approach_dfs (input, position, dictionary, solution);
      continue;
    }

    ConversionTable _dictionary = dictionary; // zaloha prevodni tabulky

    vector<Option> words;
    Wordlist::get_words(input, position, dictionary, solution, words);

    progress (input, solution, words, dictionary);

    // vyzkousime vsechna slova ze slovniku, ktera maji nejakou sanci
    for (size_t i = 0; i < words.size(); i++) {
      int cost = dictionary.match (input, position, words[i], solution);
      if (cost) { // pokud slovo pasuje
        solution.push_back(words[i].word); solution.cost += cost;
        if (position + words[i].word->text.size() == input.size()) solution.complete();
        else {
          if (Solution::all.size() < MAX_PRINT_SOLUTION || Solution::all.top() > solution)
            heap.push(solution);
        }
        solution.pop_back(); solution.cost -= cost;
      }

      // vratime prevodniu tabulku do puvodniho stavu (ze zalohy)
      dictionary = _dictionary;
    }
  }
}
