/*
  Hlavni program, ktery resi zkoumany problem.

  vstup  (stdin):  program precte jeden radek
  vystup (stdout): reseni ulohy
*/

#include "../config.h"
#include "lib/common.h"
#include "approach_dfs.h"
#include "approach_bfs.h"
#include "approach_freq.h"

time_t startTime;
double lat, lon;

int main (int argc, char *argv[]) {
  if (argc == 3) {
    lat = atof(argv[1]);
    lon = atof(argv[2]);
  }

  string input = get_input();
  if (input.size() > MAX_INPUT_SIZE) {
    cerr << "Maximalni dovolena delka vstupu je " << MAX_INPUT_SIZE << endl;
    return 0;
  }

  Wordlist::Instance()->load_dir();
  Rules::load();

  if (PHASE_1) {
    startTime = 0; // Znaci, ze se vykonava prvni faze
    if (ALG == ALG_DFS) approach_dfs(input);
    else                approach_bfs(input);
  }
  if (PHASE_2) {
    startTime = time(NULL);
    if (ALG == ALG_DFS) approach_dfs(input);
    else                approach_bfs(input);
  }

  Solution::print_all();
  return 0;
}
