#include "common.h"

/* Nacte ze standartniho vstupu jeden radek, prevede ho na mala pismena a vrati. */
string get_input () {
  string input, filtered;
  getline (cin, input);
  transform (input.begin(), input.end(), input.begin(), ::tolower);
  for(size_t i = 0; i < input.size(); i++) if('a' <= input[i] && input[i] <= 'z')
    filtered.push_back(input[i]);
  return filtered;
}

/* Funkce pro vypis aktualniho stavu prohledavani. */
static long long progress_steps = 0;
void progress (const string & input,
               const Solution & solution,
               const vector<Option> & words,
               const ConversionTable & dictionary) {
  if (!PROGRESS || !startTime) return;
  if ((++progress_steps) % PROGRESS_STEPS == 0) {
    cerr << endl << "Steps: " << progress_steps << endl;

    int position = 0;
    cerr << "  ";
    for (size_t i = 0; i < solution.size(); i++) {
      cerr << solution.words[i]->text << " ";
      position += solution.words[i]->text.size();
    }
    cerr << ": ";
    for (size_t i = position; i < input.size(); i++)
      cerr << (dictionary.get(input[i]) ? dictionary.get(input[i]) : input[i]);
    cerr << endl;

    cerr << "  running time: " << time(NULL) - startTime << endl;
    cerr << "  cost: " << solution.cost
         << "  possibilities to continue: " << words.size() << endl;
    // for (size_t i = 0; i < words.size(); ++i) cerr << " " << words[i].word->text;
    // cerr << endl;
    // cerr << "  dictionary: " << dictionary << endl;
    cerr << endl;
  }
}
