#include "common.h"

void Solution::print_all () {
  while(all.size() > MAX_PRINT_SOLUTION) all.pop();

  if (!all.size()) cout << "Nenalezeno zadne reseni." << endl;
  else {
    vector<Solution> tmp;
    while (!all.empty()) { tmp.push_back(all.top()); all.pop(); }
    cout << endl << "Reseni:" << endl;
    for (size_t i = 0; i < tmp.size(); i++) cout << tmp[tmp.size() - i - 1] << endl;
  }
}

/*
  Oznaci aktualni reseni za hotove a pokud je dostatecne dobre,
  tak ho prida do mnoziny dosud nejlepsich nalezenych reseni.
*/
void Solution::complete () {
  Option end_of_text(&(Wordlist::end_word), *this);
  cost += end_of_text.cost;
  bool already_there = false;
  for (size_t i = 0; i < all.size(); ++i) if ((&all.top())[i] == *this) {
    if (this->cost >= (&all.top())[i].cost) {
      already_there = true;
      break;
    }
  }
  if (!already_there) {
    while (all.size() >= MAX_PRINT_SOLUTION && (*this) < all.top()) all.pop();
    if (all.size() < MAX_PRINT_SOLUTION) {
      if (PROGRESS) cerr << *this << endl;
      else cerr << ".";
      all.push(*this);
    }
  }
  cost -= end_of_text.cost;
}

Solution::Solution () : cost(0) {}

// Lepsi reseni je to mensi
bool Solution::operator<  (const Solution & b) const { return cost <  b.cost; }
bool Solution::operator<= (const Solution & b) const { return cost <= b.cost; }
bool Solution::operator>  (const Solution & b) const { return cost >  b.cost; }
bool Solution::operator>= (const Solution & b) const { return cost >= b.cost; }
bool Solution::operator== (const Solution & b) const {
  string aa, bb;
  for (size_t i = 0; i < words.size(); ++i) aa += words[i]->text;
  for (size_t i = 0; i < b.words.size(); ++i) bb += b.words[i]->text;
  return aa == bb;
}

void Solution::push_back (const Word * word) { words.push_back (word); }
void Solution::pop_back () { words.pop_back(); }
void Solution::clear () { words.clear(); cost = 0; }
size_t Solution::size () const { return words.size(); }

/* Vypis reseni */
ostream & operator<< (ostream & out, const Solution & s) {
  out << setw(10) << s.cost << " -";
  for (size_t i = 0; i < s.words.size(); i++) out << " " << s.words[i]->text;
  return out;
}

priority_queue<Solution> Solution::all;
